﻿// SageTV Gadget v2.1

var BROWSE_FILTER = "Image Files:*.jpg;*.png;*.gif::";
var SETTINGS_SIZING = "?width=100&height=100";
var gImgFile = "";

function LoadSettings()
{
    System.Gadget.onSettingsClosing = SettingsClosing;
    ShowGroup(0);
    
    // Load from settings file
    gImgFile = System.Gadget.Settings.readString("Background");
    CHECKBORDER.checked = System.Gadget.Settings.read( "Border");
    MARGINSTEXT.value = System.Gadget.Settings.readString( "Margins");
    SERVERTEXT.value = System.Gadget.Settings.readString( "Server");
    PORTTEXT.value = System.Gadget.Settings.readString( "Port");
    DATETEXT.value = System.Gadget.Settings.readString( "DateFormat");
    TIMETEXT.value = System.Gadget.Settings.readString( "TimeFormat");
    UPDATETEXT.value = System.Gadget.Settings.readString( "Update");
    USERTEXT.value = System.Gadget.Settings.readString( "User");
    PASSTEXT.value = System.Gadget.Settings.readString( "Pass");
    WIDTHTEXT.value = System.Gadget.Settings.readString("Width");
    CHECKLOGOS.checked = System.Gadget.Settings.read("Logos");
    CHECKPADDING.checked = System.Gadget.Settings.read("Padding");
    CHECKDISK.checked = System.Gadget.Settings.read("ShowDisk");
    CHECKSHOWNP.checked = System.Gadget.Settings.read("ShowNowPlaying");
    NPUPDATETEXT.value = System.Gadget.Settings.readString("NPUpdate");
    NPHEIGHTTEXT.value = System.Gadget.Settings.readString("NPHeight");
    NPSTRINGTEXT.value = System.Gadget.Settings.readString("NPString");
    NPCONNECTTEXT.value = System.Gadget.Settings.readString("NPConnect");
    RSSTRINGTEXT.value = System.Gadget.Settings.readString("RecString");
    ITEMHEIGHTTEXT.value = System.Gadget.Settings.readString("RecHeight");
    
    try
    {
        var tmp = parseInt( System.Gadget.Settings.readString( "LaunchType"));
        if( tmp < 0 || tmp > 3)
            tmp = 0;
        LAUNCHCOMBO.selectedIndex = tmp;
    }
    catch( err)
    {
        LAUNCHCOMBO.selectedindex = 0;   
    }
    
    try
    {
        var tmp = parseInt( System.Gadget.Settings.readString( "Size"));
        if( tmp < 1 || tmp > 12)
            tmp = 3;
        SIZECOMBO.selectedIndex = tmp-1;
    }
    catch( err)
    {
        SIZECOMBO.selectedindex = 2;   
    }
    
    // Set image
    LoadSettingsImage();
}

function SettingsClosing(event)
{
    if (event.closeAction == event.Action.commit)
    {
        // Write to settings file
        System.Gadget.Settings.writeString( "Background", gImgFile);
        System.Gadget.Settings.write( "Border", CHECKBORDER.checked);
        System.Gadget.Settings.writeString( "Margins", MARGINSTEXT.value);
        System.Gadget.Settings.writeString( "Server", SERVERTEXT.value);
        System.Gadget.Settings.writeString( "Port", PORTTEXT.value);
        System.Gadget.Settings.writeString( "DateFormat", DATETEXT.value);
        System.Gadget.Settings.writeString( "TimeFormat", TIMETEXT.value);
        System.Gadget.Settings.writeString( "Update", UPDATETEXT.value);
        System.Gadget.Settings.writeString( "User", USERTEXT.value);
        System.Gadget.Settings.writeString( "Pass", PASSTEXT.value);
        System.Gadget.Settings.writeString( "Width", WIDTHTEXT.value);
        System.Gadget.Settings.write( "LaunchType", LAUNCHCOMBO.selectedIndex);
        System.Gadget.Settings.write( "Size", SIZECOMBO.selectedIndex + 1);
        System.Gadget.Settings.write( "Logos", CHECKLOGOS.checked);
        System.Gadget.Settings.write("Padding", CHECKPADDING.checked);
        System.Gadget.Settings.write("ShowDisk", CHECKDISK.checked);
        System.Gadget.Settings.write("ShowNowPlaying", CHECKSHOWNP.checked);
        System.Gadget.Settings.writeString("NPUpdate", NPUPDATETEXT.value);
        System.Gadget.Settings.writeString("NPHeight", NPHEIGHTTEXT.value);
        System.Gadget.Settings.writeString("NPString", NPSTRINGTEXT.value);
        System.Gadget.Settings.writeString("NPConnect", NPCONNECTTEXT.value);
        System.Gadget.Settings.writeString("RecString", RSSTRINGTEXT.value);
        System.Gadget.Settings.writeString("RecHeight", ITEMHEIGHTTEXT.value);
    }
}

function LoadSettingsImage()
{
    CURIMAGE.src = "gimage:///" + gImgFile + SETTINGS_SIZING;
}


function BROWSE_onclick() 
{
    try
    {
        var index = gImgFile.lastIndexOf( '\\');
        var newFile = System.Shell.chooseFile( true, BROWSE_FILTER, gImgFile.slice(0,index), gImgFile.slice(index+1));
        if( newFile != null)
        {
            gImgFile = newFile.path;
            LoadSettingsImage();
         }
    }
    catch( err)
    {
        //IMAGETEXT.innerText = err.Description;
    }
}

function ShowGroup(group) {
    GENERALGROUP.style.display = (group == 0) ? "block" : "none";
    DISPLAYGROUP.style.display = (group == 1) ? "block" : "none";
    RECGROUP.style.display = (group == 2) ? "block" : "none";
    NPGROUP.style.display = (group == 3) ? "block" : "none";
}